# AAC feed generator
# Expects pup JSON output holding <tr> tags, outputs xmltodict-compatible JSON
# WARNING: Dates are locale-sensitive; the RSS feed might not generate correctly with another locale.

{
    "rss": {
        "@version": "2.0",
        "channel": {
            "title": "AAC",
            "description": "El Salvador's Autordid de Aviación Civil",
            "link": "https://www.aac.gob.sv/?page_id=1006",
            "language": "es-SV",
            "pubDate": (now | strftime("%a, %d %b %Y %T %z")),
            "docs": "https://www.rssboard.org/rss-specification",
            "ttl": 1440,
            "generator": "ITSB",
            "item": [
                .[].children | {
                    "title": .[0].children[0].text,
                    "link": (
                        # The links are held in onclick attributes which set location.href to a string,
                        # so we extract the string.
                        .[3].children[0].onclick
                        | match("&#39;(.*)&#39;").captures[0].string
                        # & is escaped as we were within an HTML attribute, so this restores it
                        | sub("&amp;"; "&")
                    ),
                    "description": .[1].children[0].text,
                    "pubDate": (.[2].text | strptime("%d/%m/%Y") | mktime | strftime("%a, %d %b %Y %T %z"))
                }
            ]
        }
    }
}
